import { U as Union$1 } from '../../dist/entity-6fbc681a.esm.js';
export { a as Entity, H as HasEntity } from '../../dist/entity-6fbc681a.esm.js';
import { defaultMetadataStorage } from 'class-transformer/cjs/storage.js';

/* eslint-disable @typescript-eslint/no-var-requires */
const camelCase = require("lodash/camelCase");
const snakeCase = require("lodash/snakeCase");
function getExposeMetadataOptions(propertyName, options = {}) {
  const exposeOptions = {};
  switch (options.nameCasing) {
    case "camelCase":
      exposeOptions.name = camelCase(propertyName);
      break;
    case "snakeCase":
      exposeOptions.name = snakeCase(propertyName);
      break;
  }
  return exposeOptions;
}
function ExposeAll(options) {
  // eslint-disable-next-line @typescript-eslint/no-explicit-any
  return function (target) {
    const object = new target();
    Object.keys(object).forEach(propertyName => {
      const exposeMetadata = defaultMetadataStorage.findExposeMetadata(target, propertyName);
      defaultMetadataStorage.addExposeMetadata({
        target,
        propertyName,
        options: {
          ...getExposeMetadataOptions(propertyName, options),
          ...exposeMetadata?.options
        }
      });
    });
  };
}

function Union({
  discriminatorProperty = "type",
  subTypes = []
}) {
  return function (target, propertyKey) {
    const reflectedType = Reflect.getMetadata("design:type", target, propertyKey);
    defaultMetadataStorage.addTypeMetadata({
      target: target.constructor,
      propertyName: propertyKey,
      reflectedType,
      typeFunction: () => Union$1,
      options: {
        discriminator: {
          property: discriminatorProperty,
          subTypes
        }
      }
    });
    if (reflectedType.name === "Array") {
      defaultMetadataStorage.addTransformMetadata({
        target: target.constructor,
        propertyName: propertyKey,
        transformFn: ({
          value
        }) => value?.filter(v => !(v instanceof Union$1)),
        options: {}
      });
    }
  };
}

export { ExposeAll, Union };
